#!/bin/bash python

import time


##############################################################################
# Log class
##############################################################################
class MyLog():
  LOG_MASK_ERROR   = 0x0001
  LOG_MASK_WARNING = 0x0002
  LOG_MASK_NOTICE  = 0x0004
  LOG_MASK_DEBUG   = 0x0008
  LOG_MASK_NONE    = 0x0000
  LOG_MASK_ALL     = 0x000F

  ##############################################################################
  # Constructor
  ##############################################################################
  def __init__(self, name):
    self.mask = self.LOG_MASK_ALL
    self.fp   = None
    self.name = name
  #

  ##############################################################################
  # Set file name to log to
  ##############################################################################
  def setFile(self, fn=None):
    
    if (self.fp != None):
      self.fp.close()
      self.fp = None

    elif (fn != None):
      self.fp = open(fn, "w+")
      
    else:
      tt = time.localtime()
      fn = "%s_%4d%02d%02d_%02d%02d%02d.csv"%(self.name, tt.tm_year, tt.tm_mon, tt.tm_mday, tt.tm_hour, tt.tm_min, tt.tm_sec)
      self.fp = open(fn, "w+")
      print fn
  #

  ##############################################################################
  # Set file name to log to
  ##############################################################################
  def close(self):
    
    if (self.fp != None):
      self.fp.close()
      self.fp = None
    #
  #

  ##############################################################################
  # Set mask
  ##############################################################################
  def setMask(self, mask):
    self.mask = mask
  #

  ##############################################################################
  # Get mask
  ##############################################################################
  def getMask(self, mask):
    return self.mask
  #

  ##############################################################################
  # Error output
  ##############################################################################
  def error(self, s):
    if (self.mask & self.LOG_MASK_ERROR):
      self.string("ERR,%s"%s)
  #

  ##############################################################################
  # Warning output
  ##############################################################################
  def warning(self, s):
    if (self.mask & self.OG_MASK_WARNING):
      self.string("WRN,%s"%s)
  #

  ##############################################################################
  # Notice output
  ##############################################################################
  def notice(self, s):
    if (self.mask & self.LOG_MASK_NOTICE):
      self.string("NTC,%s"%s)
  #

  ##############################################################################
  # Debug output
  ##############################################################################
  def debug(self, s):
    if (self.mask & self.LOG_MASK_DEBUG):
      self.string("DBG,%s"%s)
  #

  ##############################################################################
  # String output
  ##############################################################################
  def string(self, s):
    t = time.localtime()
    s = "%02d:%02d:%02d,%s" % (t.tm_hour, t.tm_min, t.tm_sec, s)
    print s

    # If we have an open file, write to it
    if (self.fp != None):
      self.fp.write(s + '\n')
      self.fp.flush()
    #
  #

#
