/*****************************************************************************/
/*! @file Vectors.h
 * @brief Short description
 *
 * More information here
 *
 *  @addtogroup MyLib
 * @{
 */
/*****************************************************************************/

#ifndef VECTORS_H
#define VECTORS_H


/*****************************************************************************
 *                             Include files                                 *
 *****************************************************************************/

/*****************************************************************************
 *                             Constant Defines                              *
 *****************************************************************************/

/*****************************************************************************
 *                             Macro defines                                 *
 *****************************************************************************/

/*****************************************************************************
 *                             Enumerations (XXX_e)                          *
 *****************************************************************************/

/*****************************************************************************
 *                             Structures/unions (XXX_t)                     *
 *****************************************************************************/
/*! A 3D dimensional vector container */
typedef struct
{
  float x;  /*!< X vector component */
  float y;  /*!< Y vector component */
  float z;  /*!< Z vector component */
} vector_t;

/*****************************************************************************
 *                             Constant globals                              *
 *****************************************************************************/

/*****************************************************************************
 *                             Externs for globals                           *
 *****************************************************************************/

/*****************************************************************************
 *                             Prototypes                                    *
 *****************************************************************************/

void      vector_cross(const vector_t *a, const vector_t *b, vector_t *out);
float     vector_dot(const vector_t *a, const vector_t *b);
vector_t  vector_normalize(vector_t *a);



#endif /* VECTORS_H */
/*! @} */
